%Authors: 	Martin Holler and Kristian Bredies
%		University of Graz
%Contact	martin.holler@uni-graz.at
%Usage permited only for academic purposes
%NOTE: This is NON-OPTIMIZED matlab code



%This sript shows how to use the tv_jpeg function for TV-based JPEG decompression

%[g1,g2,tv,gap] = tv_jpeg('image_name',tol,mode)

%The above code snippet preforms the TV-jpeg decompression algorithm until the primal-dual gap is below tol.
%Mode can either be

%-{'simulate',rate}, where JPEG compression is simulated im Matlab and the quantization matrix is multiplied by rate.

%or

%{'realdata'}. In that case, image name is expected to refer to a grayscale JPEG compressed image and the Independent JPEG Group's JPEG runtime library is used to get the source data. See the node at the end of that page for further information.

%The standard decompression is saved in g1, the improved decompression in g2.
%tv and gap store the development of the total variation functional and the primal-dual gap during iteratin, respectively.

display(['Example usage with synthetic data: ']);
[g1,g2,tv,gap] = tv_jpeg('bird.png',0.1,{'simulate',1});

%display(['Example usage with real data: ']);
%[g1,g2,tv,gap] = tv_jpeg('bird.jpg',0.1,{'realdata'});







%NOTE: 	    To decompress real JPEG Files
%	    Independent JPEG Group's JPEG runtime library (tested with version 6.2)
%	    and header files must be installed and data_handling/read_jpeg_data.cpp must be compiled.

%           After installing libjpeg, compile with
%               mex read_data.cpp -ljpeg
%	    in matlab
